# $Revision: 1.64 $, $Date: 2006/01/30 23:34:57 $
#
# Conditional build:
%bcond_without	doc	# don't generate documentation (bootstrap build w/o gnustep-base)
#
Summary:	GNUstep Base library package
Summary(pl):	Podstawowa biblioteka GNUstep
Name:		gnustep-base
Version:	1.11.2
Release:	2
License:	LGPL/GPL
Group:		Libraries
Source0:	ftp://ftp.gnustep.org/pub/gnustep/core/%{name}-%{version}.tar.gz
# Source0-md5:	f370c912a6150371df0e1bb63eab50d2
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Patch0:		%{name}-pass-arguments.patch
URL:		http://www.gnustep.org/
%{?with_doc:BuildRequires:	docbook-dtd41-sgml}
BuildRequires:	ffcall-devel
BuildRequires:	gcc-objc
BuildRequires:	gmp-devel
%{?with_doc:BuildRequires:	gnustep-base-devel >= 1.8.0}
BuildRequires:	gnustep-make-devel >= 1.11.2
BuildRequires:	libxml2-devel >= 2.3.0
BuildRequires:	openssl-devel >= 0.9.7d
BuildRequires:	zlib-devel
Requires(post):	/sbin/ldconfig
Requires(post,preun):	/sbin/chkconfig
Requires(triggerpostun):	sed >= 4.0
Requires:	glibc >= 6:2.3.5-7.6
Requires:	gnustep-make >= 1.11.2
# with gdomap in /etc/services
Requires:	setup >= 2.4.3
Conflicts:	gnustep-core
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define         _prefix         /usr/%{_lib}/GNUstep

%define		libcombo	gnu-gnu-gnu
%define		gsos		linux-gnu
%ifarch %{ix86}
%define		gscpu		ix86
%else
# also s/alpha.*/alpha/, but we use only "alpha" arch for now
%define		gscpu		%(echo %{_target_cpu} | sed -e 's/amd64/x86_64/;s/ppc/powerpc/')
%endif

%description
The GNUstep Base Library is a library of general-purpose,
non-graphical Objective C objects. For example, it includes classes
for strings, object collections, byte streams, typed coders,
invocations, notifications, notification dispatchers, moments in time,
network ports, remote object messaging support (distributed objects),
event loops, and random number generators.

%description -l pl
Podstawowa biblioteka GNUstep jest bibliotek innych ni graficzne
obiektw oglnego przeznaczenia dla Objective C. Zawiera np. klasy dla
stringw, kolekcji, strumieni, koderw typw, powiadamiania, portw
sieci, obiektw rozproszonych, ptli zdarze, generatorw liczb
losowych.

%package devel
Summary:	GNUstep Base headers
Summary(pl):	Pliki nagwkowe podstawowej biblioteki GNUstep
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	ffcall-devel
Requires:	gcc-objc
Requires:	gmp-devel
Requires:	gnustep-make-devel >= 1.11.2
Requires:	libxml2-devel
Requires:	zlib-devel
Conflicts:	gnustep-core

%description devel
Header files required to build applications against the GNUstep Base
library.

%description devel -l pl
Pliki nagwkowe potrzebne do budowania aplikacji uywajcych
podstawowej biblioteki GNUstep.

%prep
%setup -q
%patch0 -p1

%build
export GNUSTEP_MAKEFILES=%{_prefix}/System/Library/Makefiles
export GNUSTEP_TARGET_DIR=%{gscpu}/linux-gnu

# gnustep can use one of 3 ways of getting argc,argv,env:
# - /proc (default on Linux) - gnustep programs won't run in procless system
# - fake-main hack (main is secretly renamed and wrapped)
# - pass-arguments (program must call NSProcessInfo initialize)
%configure \
	--enable-pass-arguments

%{__make} \
	messages=yes

%if %{with doc}
export LD_LIBRARY_PATH=`pwd`/Source/obj
# requires already installed gnustep-base
# XXX: GNUSTEP_OBJ_PREFIX=obj is workaround for Tools/DocMakefile
%{__make} -C Documentation \
	GNUSTEP_OBJ_PREFIX=obj
%{__make} -C Documentation/manual
%endif

%install
rm -rf $RPM_BUILD_ROOT
export GNUSTEP_MAKEFILES=%{_prefix}/System/Library/Makefiles
export GNUSTEP_TARGET_DIR=%{gscpu}/linux-gnu

%{__make} install \
	INSTALL_ROOT_DIR=$RPM_BUILD_ROOT \
	GNUSTEP_INSTALLATION_DIR=$RPM_BUILD_ROOT%{_prefix}/System

%if %{with doc}
%{__make} -C Documentation install \
	GNUSTEP_INSTALLATION_DIR=$RPM_BUILD_ROOT%{_prefix}/System
%{__make} -C Documentation/manual install \
	GNUSTEP_INSTALLATION_DIR=$RPM_BUILD_ROOT%{_prefix}/System
# not (yet?) supported by rpm-compress-doc
find $RPM_BUILD_ROOT%{_prefix}/System/Library/Documentation \
	-type f -a ! -name '*.html' -a ! -name '*.gz' -a ! -name '*.jpg' -a ! -name '*.css' | xargs gzip -9nf
%endif

install -d $RPM_BUILD_ROOT%{_initrddir}
sed -e "s!@TOOLSARCHDIR@!%{_prefix}/System/Tools/%{gscpu}/%{gsos}!" %{SOURCE1} \
	> $RPM_BUILD_ROOT%{_initrddir}/gnustep

install -d $RPM_BUILD_ROOT/etc/sysconfig
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/gnustep

echo 'GMT' > $RPM_BUILD_ROOT%{_prefix}/System/Library/Libraries/Resources/gnustep-base/NSTimeZones/localtime

install -d $RPM_BUILD_ROOT/etc/ld.so.conf.d
echo '%{_prefix}/System/Library/Libraries/%{gscpu}/%{gsos}/%{libcombo}' > $RPM_BUILD_ROOT/etc/ld.so.conf.d/%{name}.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
/sbin/chkconfig --add gnustep
if [ -f /var/lock/subsys/gnustep ]; then
	/etc/rc.d/init.d/gnustep restart 1>&2
else
	echo "Run \"/etc/rc.d/init.d/gnustep start\" to start gnustep services."
fi

%preun
if [ "$1" = "0" ]; then
	if [ -f /var/lock/subsys/gnustep ]; then
		/etc/rc.d/init.d/gnustep stop 1>&2
	fi
	/sbin/chkconfig --del gnustep
fi

%postun -p /sbin/ldconfig

%triggerpostun -- %{name} < 1.11.0-1.1
sed -i -e "/^%(echo %{_prefix}/Libraries/%{gscpu}/%{gsos}/%{libcombo} | sed -e 's,/,\\/,g')$/d" /etc/ld.so.conf

%files
%defattr(644,root,root,755)
%doc ChangeLog*
/etc/ld.so.conf.d/%{name}.conf
%attr(754,root,root) %{_initrddir}/gnustep
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/gnustep

%dir %{_prefix}/System/Library/Bundles/SSL.bundle
%{_prefix}/System/Library/Bundles/SSL.bundle/Resources
%attr(755,root,root) %{_prefix}/System/Library/Bundles/SSL.bundle/%{gscpu}

%docdir %{_prefix}/System/Library/Documentation
%if %{with doc}
%{_prefix}/System/Library/Documentation/*.jpg
%{_prefix}/System/Library/Documentation/index.html
%{_prefix}/System/Library/Documentation/style.css
%dir %{_prefix}/System/Library/Documentation/Developer/Base
%{_prefix}/System/Library/Documentation/Developer/Base/ReleaseNotes
%endif
%dir %{_prefix}/System/Library/Documentation/man/man8
%{_prefix}/System/Library/Documentation/man/man1/*.1*
%{_prefix}/System/Library/Documentation/man/man8/*.8*

%dir %{_prefix}/System/Library/DTDs
%{_prefix}/System/Library/DTDs/*.dtd
%{_prefix}/System/Library/DTDs/*.rnc

%dir %{_prefix}/System/Library/Libraries/Resources/gnustep-base
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/*.plist
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/English.lproj
%lang(fr) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/French.lproj
%lang(de) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/German.lproj
%lang(it) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Italian.lproj
%lang(es) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Spanish.lproj
%lang(zh_TW) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/TraditionalChinese.lproj
%dir %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/Locale.*
%lang(nl) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/Dutch
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/English
%lang(fr) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/French
%lang(de) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/German
%lang(hu) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/Hungarian
%lang(it) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/Italian
%lang(ru) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/Russian
%lang(sk) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/Slovak
%lang(es) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/Spanish
%lang(zh_TW) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/TraditionalChinese
%lang(uk) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/Languages/UkraineRussian
%dir %{_prefix}/System/Library/Libraries/Resources/gnustep-base/NSTimeZones
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/NSTimeZones/GNUmakefile
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/NSTimeZones/GNUstep_zones
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/NSTimeZones/README
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/NSTimeZones/abbreviations
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/NSTimeZones/regions
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/NSTimeZones/zones
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/NSTimeZones/*.m
%{_prefix}/System/Library/Libraries/Resources/gnustep-base/NSTimeZones/*.plist
%config(noreplace) %verify(not md5 mtime size) %{_prefix}/System/Library/Libraries/Resources/gnustep-base/NSTimeZones/localtime

%attr(755,root,root) %{_prefix}/System/Library/Libraries/%{gscpu}/%{gsos}/%{libcombo}/lib*.so.*

%dir %{_prefix}/System/Tools/%{gscpu}
%dir %{_prefix}/System/Tools/%{gscpu}/%{gsos}
# is suid necessary here??? it runs as daemon...
#%attr(4755,root,root) %{_prefix}/System/Tools/%{gscpu}/%{gsos}/gdomap
%attr(755,root,root) %{_prefix}/System/Tools/%{gscpu}/%{gsos}/gdomap
%dir %{_prefix}/System/Tools/%{gscpu}/%{gsos}/%{libcombo}
%attr(755,root,root) %{_prefix}/System/Tools/%{gscpu}/%{gsos}/%{libcombo}/*

%files devel
%defattr(644,root,root,755)
%if %{with doc}
%docdir %{_prefix}/System/Library/Documentation
%{_prefix}/System/Library/Documentation/Developer/Base/General
%{_prefix}/System/Library/Documentation/Developer/Base/ProgrammingManual
%{_prefix}/System/Library/Documentation/Developer/Base/Reference
%{_prefix}/System/Library/Documentation/Developer/BaseAdditions
%{_prefix}/System/Library/Documentation/Developer/CodingStandards
%{_prefix}/System/Library/Documentation/Developer/Tools
%{_prefix}/System/Library/Documentation/info/*.info*
%endif

%{_prefix}/System/Library/Headers/%{libcombo}/Foundation
%{_prefix}/System/Library/Headers/%{libcombo}/GNUstepBase
%{_prefix}/System/Library/Headers/%{libcombo}/gnustep
%{_prefix}/System/Library/Headers/%{libcombo}/%{gscpu}/%{gsos}/*.h

%{_prefix}/System/Library/Libraries/%{gscpu}/%{gsos}/%{libcombo}/lib*.so
%dir %{_prefix}/System/Library/Makefiles/Additional
%{_prefix}/System/Library/Makefiles/Additional/base.make

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: gnustep-base.spec,v $
Revision 1.64  2006/01/30 23:34:57  baggins
- release 2
- use sysconfig for init script

Revision 1.63  2006/01/15 21:58:49  qboosh
- updated to 1.11.2

Revision 1.62  2005/12/12 16:24:19  glen
- adapterized (sorted %verify attrs)

Revision 1.61  2005/10/22 11:48:13  qboosh
- updated to 1.11.1, updated pass-arguments patch

Revision 1.60  2005/10/21 10:06:36  glen
- no flags for ld.so.conf file

Revision 1.59  2005/10/20 15:01:49  glen
- forgot %files; rel 3

Revision 1.58  2005/10/20 14:27:39  glen
- use ld.so.conf.d, rel 2

Revision 1.57  2005/07/26 22:07:23  qboosh
- updated to 1.11.0 (note: new soname)
- removed obsolete link patch

Revision 1.56  2005/04/24 20:13:25  qboosh
- updated to 1.10.3

Revision 1.55  2004/11/22 07:49:49  qboosh
- removed dirs belonging to gnustep-make

Revision 1.54  2004/10/31 14:51:01  qboosh
- updated to 1.10.1, pass-arguments patch is back (updated)
- fixed docs build on when gnustep-base < 1.10 is installed

Revision 1.53  2004/09/30 18:10:41  aredridel
- up to 0.10.0

Revision 1.52  2004/06/27 17:42:59  qboosh
- added pass-arguments patch, release 2

Revision 1.51  2004/06/24 21:18:46  qboosh
- release 1

Revision 1.50  2004/06/23 21:38:22  qboosh
- fixed ppc

Revision 1.49  2004/06/23 20:40:45  qboosh
- temporary release 0.1 for Ac bootstrap

Revision 1.48  2004/06/23 20:40:17  qboosh
- removed obsolete ssl patch
- use pass-arguments method to support procless environments
- updated files

Revision 1.47  2004/06/13 05:47:56  aredridel
- up to 1.9.2

Revision 1.46  2004/03/19 23:46:26  ankry
- massive change: BR openssl-devel >= 0.9.7d

Revision 1.45  2004/03/03 13:08:29  qboosh
- release 1 for normal Ac build

Revision 1.44  2004/03/03 07:47:18  qboosh
- amd64 changes, strict internal deps, BR gnustep-make-devel with newer dir layout
- release 0.1 for bootstrap

Revision 1.43  2004/03/02 23:57:33  qboosh
- link patch is back (updated)
- added ssl patch - SSL bundle is back
- added Developer/Base/General docs to -devel

Revision 1.42  2004/03/02 05:41:17  aredridel
- up to 1.9.1

Revision 1.41  2004/02/15 00:16:46  eothane
- bcond style, changelog cleanup

Revision 1.40  2003/12/27 01:52:44  aredridel
- up to 1.9.0

Revision 1.39  2003/09/30 20:18:23  eothane
- ahh, what the hell: openssl 0.9.7c

Revision 1.38  2003/09/30 14:58:54  aredridel
- updated to 1.8.0 (Second released 1.8.0 -- first was broken)

Revision 1.37  2003/09/16 15:27:55  aredridel
- updated to 1.7.4

Revision 1.36  2003/08/29 16:08:09  qboosh
- Headers/%%{libcombo}/%%{gscpu}{,%%{gsos}} dirs belong to gnustep-make
- man1 dir belongs to gnustep-make now

Revision 1.35  2003/08/25 08:46:09  qboosh
- use standard zh_TW instead of tw for TraditionalChinese

Revision 1.34  2003/08/25 00:57:05  aredridel
- updated to 1.7.3

Revision 1.33  2003/08/11 22:46:30  ankry
- cosmetics

Revision 1.32  2003/07/26 01:05:49  qboosh
- added gdnc(1) manual

Revision 1.31  2003/07/25 21:49:13  aredridel
- fixed syntax error in log message

Revision 1.30  2003/07/25 18:56:05  aredridel
- updated to 1.7.2

Revision 1.29  2003/07/19 23:51:27  qboosh
- updated to 1.7.1
- moved .init from spec here-document to Source1
- moved devel docs to -devel

Revision 1.28  2003/05/26 16:25:04  malekith
- massive attack: adding Source-md5

Revision 1.27  2003/05/25 05:48:19  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.26  2003/05/14 20:40:45  qboosh
- up to 1.6.0, updated link patch

Revision 1.25  2003/03/02 21:08:09  qwark
- new version 1.5.2 - ready for tests

Revision 1.24  2003/02/13 14:03:33  juandon
- force to use openssl >= 0.9.7, idea by kloczek

Revision 1.23  2003/01/27 08:40:22  qwark
- fix in BR & init script

Revision 1.22  2002/12/31 17:11:56  qboosh
- fixed Group - the most important thing in package is library
- added missing -ldl in link patch

Revision 1.21  2002/12/29 13:44:35  qboosh
- License fix - libraries are LGPL, tools GPL
- added Requires list for -devel
- added doc (with bcond - requires gnustep-base already installed)
- release 1

Revision 1.20  2002/12/29 00:14:49  qboosh
- added link patch for correct libgnustep-base.so linking on Linux
- BR: ffcall-devel (it's optional on x86, required on ppc)

Revision 1.19  2002/12/28 20:56:15  qboosh
- some work and cleanups - builds now

Revision 1.18  2002/12/23 09:33:54  qwark
- updated to 1.5.1 - not working yet -ac/am fix needed

Revision 1.17  2002/11/01 13:27:32  malekith
- fixed br's

Revision 1.16  2002/04/25 16:27:49  arturs
- fixed a small typo

Revision 1.15  2002/02/23 02:17:46  kloczek
- adapterized.

Revision 1.14  2002/02/22 23:29:00  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.13  2002/01/18 02:13:09  kloczek
- perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.12  2001/11/13 13:22:38  ankry
- patch0 obsolete, added BR, fixed paths

Revision 1.11  2001/09/28 12:21:43  marcus
- new version 1.0.2

Revision 1.10  2001/09/24 13:08:53  qboosh
- Prereq: /sbin/chkconfig
- pl translations
NOTE: %%install and %%files should be rewritten

Revision 1.9  2001/07/26 05:42:08  saq
- reverting last change: removing new macros from %p{re,ost}{,un}

Revision 1.7  2001/05/02 16:29:04  qboosh
- adapterized and made spec %%debug ready or added using %%rpm*flags macros

Revision 1.6  2000/12/09 17:55:14  jajcus
- file owners fixed (semi-automatically)
  (no special user (like http/news) should own his home directory nor
  files it doesn't create)

Revision 1.5  2000/06/09 07:54:41  kloczek
- more %%{__make} macros.

Revision 1.4  2000/06/09 07:22:52  kloczek
- added using %%{__make} macro.

Revision 1.3  2000/05/20 13:37:50  kloczek
- spec adapterized and partialy rewrited.

* Sat Sep 18 1999 Christopher Seawood <cls@seawood.org>
- Version 0.6.0
- Added unicode patch to make sure unicode headers were installed

* Sat Aug 07 1999 Christopher Seawood <cls@seawood.org>
- Updated to cvs dawn_6 branch

* Fri Jun 25 1999 Christopher Seawood <cls@seawood.org>
- Split into separate rpm from gnustep-core
- Build from cvs snapshot
- Added header patch
- Split into main & -devel packages
